/* Convert.c generated by valac 0.38.10, the Vala compiler
 * generated from Convert.vala, do not modify */

/*
 * Copyright 2015 Jiří Janoušek <janousek.jiri@gmail.com>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met: 
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>

#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);



void drt_int64_to_bin (gint64 val, guint8** _result_, int* _result__length1);
gboolean drt_bin_to_int64 (guint8* array, int array_length1, gint64* _result_);
void drt_bin_to_hex (guint8* array, int array_length1, gchar* * _result_, gchar separator);
void drt_bin_to_hex_buf (guint8* array, int array_length1, GString* buffer, gchar separator);
gboolean drt_uint8v_equal (guint8* array1, int array1_length1, guint8* array2, int array2_length1);
gboolean drt_hex_to_bin (const gchar* hex, guint8** _result_, int* _result__length1, gchar separator);
gboolean drt_hex_to_int64 (const gchar* hex, gint64* _result_, gchar separator);
void drt_int64_to_hex (gint64 val, gchar* * _result_, gchar separator);
void drt_uint32_to_bytes (guint8** buffer, int* buffer_length1, guint32 data, guint offset);
void drt_int32_to_bytes (guint8** buffer, int* buffer_length1, gint32 data, guint offset);
void drt_uint32_from_bytes (guint8* buffer, int buffer_length1, guint32* data, guint offset);
void drt_int32_from_bytes (guint8* buffer, int buffer_length1, gint32* data, guint offset);


/**
 * Convert int64 value to byte array 
 * 
 * @param val       value to convert
 * @param result    byte array representation (8 bytes)
 */
void drt_int64_to_bin (gint64 val, guint8** _result_, int* _result__length1) {
	guint8* _vala_result = NULL;
	int _vala_result_length1 = 0;
	gint size = 0;
	gint _tmp0_;
	guint8* _tmp1_;
	size = (gint) sizeof (gint64);
	_tmp0_ = size;
	_tmp1_ = g_new0 (guint8, _tmp0_);
	_vala_result = (g_free (_vala_result), NULL);
	_vala_result = _tmp1_;
	_vala_result_length1 = _tmp0_;
	{
		gint i = 0;
		gint _tmp2_;
		_tmp2_ = size;
		i = _tmp2_ - 1;
		{
			gboolean _tmp3_ = FALSE;
			_tmp3_ = TRUE;
			while (TRUE) {
				gint _tmp5_;
				guint8* _tmp6_;
				gint _tmp6__length1;
				gint _tmp7_;
				gint64 _tmp8_;
				guint8 _tmp9_;
				gint64 _tmp10_;
				if (!_tmp3_) {
					gint _tmp4_;
					_tmp4_ = i;
					i = _tmp4_ - 1;
				}
				_tmp3_ = FALSE;
				_tmp5_ = i;
				if (!(_tmp5_ >= 0)) {
					break;
				}
				_tmp6_ = _vala_result;
				_tmp6__length1 = _vala_result_length1;
				_tmp7_ = i;
				_tmp8_ = val;
				_tmp6_[_tmp7_] = (guint8) (_tmp8_ & 0xFF);
				_tmp9_ = _tmp6_[_tmp7_];
				_tmp10_ = val;
				val = _tmp10_ >> 8;
			}
		}
	}
	if (_result_) {
		*_result_ = _vala_result;
	} else {
		_vala_result = (g_free (_vala_result), NULL);
	}
	if (_result__length1) {
		*_result__length1 = _vala_result_length1;
	}
}


/**
 * Converts byte array to int64 value
 * 
 * @param array     byte array to convert
 * @param result    converted value
 * @return          true on success, false on overflow
 */
gboolean drt_bin_to_int64 (guint8* array, int array_length1, gint64* _result_) {
	gint64 _vala_result = 0LL;
	gboolean result = FALSE;
	guint8* _tmp0_;
	gint _tmp0__length1;
	_vala_result = (gint64) 0;
	_tmp0_ = array;
	_tmp0__length1 = array_length1;
	if (((gulong) _tmp0__length1) > sizeof (gint64)) {
		result = FALSE;
		if (_result_) {
			*_result_ = _vala_result;
		}
		return result;
	}
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp1_ = FALSE;
			_tmp1_ = TRUE;
			while (TRUE) {
				gint _tmp3_;
				guint8* _tmp4_;
				gint _tmp4__length1;
				gint64 _tmp5_;
				gint64 _tmp6_;
				guint8* _tmp7_;
				gint _tmp7__length1;
				gint _tmp8_;
				guint8 _tmp9_;
				if (!_tmp1_) {
					gint _tmp2_;
					_tmp2_ = i;
					i = _tmp2_ + 1;
				}
				_tmp1_ = FALSE;
				_tmp3_ = i;
				_tmp4_ = array;
				_tmp4__length1 = array_length1;
				if (!(_tmp3_ < _tmp4__length1)) {
					break;
				}
				_tmp5_ = _vala_result;
				_vala_result = _tmp5_ << 8;
				_tmp6_ = _vala_result;
				_tmp7_ = array;
				_tmp7__length1 = array_length1;
				_tmp8_ = i;
				_tmp9_ = _tmp7_[_tmp8_];
				_vala_result = _tmp6_ | ((gint64) (_tmp9_ & 0xFF));
			}
		}
	}
	result = TRUE;
	if (_result_) {
		*_result_ = _vala_result;
	}
	return result;
}


/**
 * Converts byte array to hexadecimal string.
 * 
 * @param array        byte array to convert
 * @param result       converted value
 * @param separator    separator of hexadecimal pairs ('\0' for none)
 */
void drt_bin_to_hex (guint8* array, int array_length1, gchar* * _result_, gchar separator) {
	gchar* _vala_result = NULL;
	gint _tmp0_ = 0;
	gchar _tmp1_;
	gint size = 0;
	GString* buffer = NULL;
	GString* _tmp4_;
	guint8* _tmp5_;
	gint _tmp5__length1;
	gchar _tmp6_;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	_tmp1_ = separator;
	if (_tmp1_ == '\0') {
		guint8* _tmp2_;
		gint _tmp2__length1;
		_tmp2_ = array;
		_tmp2__length1 = array_length1;
		_tmp0_ = 2 * _tmp2__length1;
	} else {
		guint8* _tmp3_;
		gint _tmp3__length1;
		_tmp3_ = array;
		_tmp3__length1 = array_length1;
		_tmp0_ = (3 * _tmp3__length1) - 1;
	}
	size = _tmp0_;
	_tmp4_ = g_string_sized_new ((gsize) size);
	buffer = _tmp4_;
	_tmp5_ = array;
	_tmp5__length1 = array_length1;
	_tmp6_ = separator;
	drt_bin_to_hex_buf (_tmp5_, _tmp5__length1, buffer, _tmp6_);
	_tmp7_ = buffer->str;
	_tmp8_ = g_strdup (_tmp7_);
	_g_free0 (_vala_result);
	_vala_result = _tmp8_;
	_g_string_free0 (buffer);
	if (_result_) {
		*_result_ = _vala_result;
	} else {
		_g_free0 (_vala_result);
	}
}


/**
 * Converts byte array to hexadecimal string and stores in buffer.
 * 
 * @param array        byte array to convert
 * @param buffer       where to store converted value in
 * @param separator    separator of hexadecimal pairs ('\0' for none)
 */
static gchar string_get (const gchar* self, glong index) {
	gchar result = '\0';
	glong _tmp0_;
	gchar _tmp1_;
	g_return_val_if_fail (self != NULL, '\0');
	_tmp0_ = index;
	_tmp1_ = ((gchar*) self)[_tmp0_];
	result = _tmp1_;
	return result;
}


void drt_bin_to_hex_buf (guint8* array, int array_length1, GString* buffer, gchar separator) {
	gchar* hex_chars = NULL;
	gchar* _tmp0_;
	g_return_if_fail (buffer != NULL);
	_tmp0_ = g_strdup ("0123456789abcdef");
	hex_chars = _tmp0_;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp1_ = FALSE;
			_tmp1_ = TRUE;
			while (TRUE) {
				gint _tmp3_;
				guint8* _tmp4_;
				gint _tmp4__length1;
				gboolean _tmp5_ = FALSE;
				gint _tmp6_;
				GString* _tmp10_;
				const gchar* _tmp11_;
				guint8* _tmp12_;
				gint _tmp12__length1;
				gint _tmp13_;
				guint8 _tmp14_;
				gchar _tmp15_;
				GString* _tmp16_;
				const gchar* _tmp17_;
				guint8* _tmp18_;
				gint _tmp18__length1;
				gint _tmp19_;
				guint8 _tmp20_;
				gchar _tmp21_;
				if (!_tmp1_) {
					gint _tmp2_;
					_tmp2_ = i;
					i = _tmp2_ + 1;
				}
				_tmp1_ = FALSE;
				_tmp3_ = i;
				_tmp4_ = array;
				_tmp4__length1 = array_length1;
				if (!(_tmp3_ < _tmp4__length1)) {
					break;
				}
				_tmp6_ = i;
				if (_tmp6_ > 0) {
					gchar _tmp7_;
					_tmp7_ = separator;
					_tmp5_ = _tmp7_ != '\0';
				} else {
					_tmp5_ = FALSE;
				}
				if (_tmp5_) {
					GString* _tmp8_;
					gchar _tmp9_;
					_tmp8_ = buffer;
					_tmp9_ = separator;
					g_string_append_c (_tmp8_, _tmp9_);
				}
				_tmp10_ = buffer;
				_tmp11_ = hex_chars;
				_tmp12_ = array;
				_tmp12__length1 = array_length1;
				_tmp13_ = i;
				_tmp14_ = _tmp12_[_tmp13_];
				_tmp15_ = string_get (_tmp11_, (glong) ((_tmp14_ >> 4) & 0x0F));
				_tmp16_ = g_string_append_c (_tmp10_, _tmp15_);
				_tmp17_ = hex_chars;
				_tmp18_ = array;
				_tmp18__length1 = array_length1;
				_tmp19_ = i;
				_tmp20_ = _tmp18_[_tmp19_];
				_tmp21_ = string_get (_tmp17_, (glong) (_tmp20_ & 0x0F));
				g_string_append_c (_tmp16_, _tmp21_);
			}
		}
	}
	_g_free0 (hex_chars);
}


gboolean drt_uint8v_equal (guint8* array1, int array1_length1, guint8* array2, int array2_length1) {
	gboolean result = FALSE;
	guint8* _tmp0_;
	gint _tmp0__length1;
	guint8* _tmp1_;
	gint _tmp1__length1;
	_tmp0_ = array1;
	_tmp0__length1 = array1_length1;
	_tmp1_ = array2;
	_tmp1__length1 = array2_length1;
	if (_tmp0__length1 != _tmp1__length1) {
		result = FALSE;
		return result;
	}
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp2_ = FALSE;
			_tmp2_ = TRUE;
			while (TRUE) {
				gint _tmp4_;
				guint8* _tmp5_;
				gint _tmp5__length1;
				guint8* _tmp6_;
				gint _tmp6__length1;
				gint _tmp7_;
				guint8 _tmp8_;
				guint8* _tmp9_;
				gint _tmp9__length1;
				gint _tmp10_;
				guint8 _tmp11_;
				if (!_tmp2_) {
					gint _tmp3_;
					_tmp3_ = i;
					i = _tmp3_ + 1;
				}
				_tmp2_ = FALSE;
				_tmp4_ = i;
				_tmp5_ = array1;
				_tmp5__length1 = array1_length1;
				if (!(_tmp4_ < _tmp5__length1)) {
					break;
				}
				_tmp6_ = array1;
				_tmp6__length1 = array1_length1;
				_tmp7_ = i;
				_tmp8_ = _tmp6_[_tmp7_];
				_tmp9_ = array2;
				_tmp9__length1 = array2_length1;
				_tmp10_ = i;
				_tmp11_ = _tmp9_[_tmp10_];
				if (_tmp8_ != _tmp11_) {
					result = FALSE;
					return result;
				}
			}
		}
	}
	result = TRUE;
	return result;
}


/**
 * Converts hexadecimal string to byte array
 * 
 * @param hex          hexadecimal string to convert
 * @param result       byte array
 * @param separator    separator of hexadecimal pairs ('\0' for none)
 * @return             true on success, false on failure (invalid input)
 */
gboolean drt_hex_to_bin (const gchar* hex, guint8** _result_, int* _result__length1, gchar separator) {
	guint8* _vala_result = NULL;
	int _vala_result_length1 = 0;
	gboolean result = FALSE;
	guint8* hex_data = NULL;
	const gchar* _tmp0_;
	gint hex_data_length1;
	gint _hex_data_size_;
	const gchar* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gboolean _tmp5_ = FALSE;
	const gchar* _tmp6_;
	gint size = 0;
	guint8* _tmp8_;
	gint _tmp8__length1;
	gchar _tmp9_;
	gint _tmp15_;
	guint8* _tmp16_;
	guint8 c = 0U;
	guint8 j = 0U;
	g_return_val_if_fail (hex != NULL, FALSE);
	_vala_result = (g_free (_vala_result), NULL);
	_vala_result = NULL;
	_vala_result_length1 = 0;
	_tmp0_ = hex;
	hex_data = (guint8*) _tmp0_;
	hex_data_length1 = -1;
	_hex_data_size_ = hex_data_length1;
	_tmp1_ = hex;
	_tmp2_ = strlen (_tmp1_);
	_tmp3_ = _tmp2_;
	hex_data_length1 = _tmp3_;
	_tmp4_ = hex_data_length1;
	_tmp6_ = hex;
	if (_tmp6_ != NULL) {
		guint8* _tmp7_;
		gint _tmp7__length1;
		_tmp7_ = hex_data;
		_tmp7__length1 = hex_data_length1;
		_tmp5_ = _tmp7__length1 > 0;
	} else {
		_tmp5_ = FALSE;
	}
	g_return_val_if_fail (_tmp5_, FALSE);
	_tmp8_ = hex_data;
	_tmp8__length1 = hex_data_length1;
	size = _tmp8__length1;
	_tmp9_ = separator;
	if (_tmp9_ != '\0') {
		gint _tmp10_;
		gint _tmp11_;
		gint _tmp12_;
		_tmp10_ = size;
		size = _tmp10_ + 1;
		_tmp11_ = size;
		if ((_tmp11_ % 3) != 0) {
			result = FALSE;
			if (_result_) {
				*_result_ = _vala_result;
			} else {
				_vala_result = (g_free (_vala_result), NULL);
			}
			if (_result__length1) {
				*_result__length1 = _vala_result_length1;
			}
			return result;
		}
		_tmp12_ = size;
		size = _tmp12_ / 3;
	} else {
		gint _tmp13_;
		gint _tmp14_;
		_tmp13_ = size;
		if ((_tmp13_ % 2) != 0) {
			result = FALSE;
			if (_result_) {
				*_result_ = _vala_result;
			} else {
				_vala_result = (g_free (_vala_result), NULL);
			}
			if (_result__length1) {
				*_result__length1 = _vala_result_length1;
			}
			return result;
		}
		_tmp14_ = size;
		size = _tmp14_ / 2;
	}
	_tmp15_ = size;
	_tmp16_ = g_new0 (guint8, _tmp15_);
	_vala_result = (g_free (_vala_result), NULL);
	_vala_result = _tmp16_;
	_vala_result_length1 = _tmp15_;
	{
		gint i = 0;
		gint pos = 0;
		i = 0;
		pos = 0;
		{
			gboolean _tmp17_ = FALSE;
			_tmp17_ = TRUE;
			while (TRUE) {
				gboolean _tmp19_ = FALSE;
				guint8* _tmp20_;
				gint _tmp20__length1;
				gint _tmp21_;
				guint8 _tmp22_;
				guint8 _tmp23_;
				guint8 _tmp26_;
				gchar _tmp27_;
				guint8 _tmp29_;
				gint _tmp30_;
				if (!_tmp17_) {
					gint _tmp18_;
					_tmp18_ = i;
					i = _tmp18_ + 1;
				}
				_tmp17_ = FALSE;
				_tmp20_ = hex_data;
				_tmp20__length1 = hex_data_length1;
				_tmp21_ = pos;
				pos = _tmp21_ + 1;
				_tmp22_ = _tmp20_[_tmp21_];
				c = _tmp22_;
				_tmp23_ = c;
				if (((gint) _tmp23_) != 0) {
					gint _tmp24_;
					gint _tmp25_;
					_tmp24_ = i;
					_tmp25_ = size;
					_tmp19_ = _tmp24_ < (2 * _tmp25_);
				} else {
					_tmp19_ = FALSE;
				}
				if (!_tmp19_) {
					break;
				}
				_tmp26_ = c;
				_tmp27_ = separator;
				if (_tmp26_ == ((guint8) _tmp27_)) {
					gint _tmp28_;
					_tmp28_ = i;
					i = _tmp28_ - 1;
					continue;
				}
				_tmp29_ = c;
				switch (_tmp29_) {
					case '0':
					{
						j = (guint8) 0;
						break;
					}
					case '1':
					{
						j = (guint8) 1;
						break;
					}
					case '2':
					{
						j = (guint8) 2;
						break;
					}
					case '3':
					{
						j = (guint8) 3;
						break;
					}
					case '4':
					{
						j = (guint8) 4;
						break;
					}
					case '5':
					{
						j = (guint8) 5;
						break;
					}
					case '6':
					{
						j = (guint8) 6;
						break;
					}
					case '7':
					{
						j = (guint8) 7;
						break;
					}
					case '8':
					{
						j = (guint8) 8;
						break;
					}
					case '9':
					{
						j = (guint8) 9;
						break;
					}
					case 'A':
					{
						j = (guint8) 10;
						break;
					}
					case 'B':
					{
						j = (guint8) 11;
						break;
					}
					case 'C':
					{
						j = (guint8) 12;
						break;
					}
					case 'D':
					{
						j = (guint8) 13;
						break;
					}
					case 'E':
					{
						j = (guint8) 14;
						break;
					}
					case 'F':
					{
						j = (guint8) 15;
						break;
					}
					case 'a':
					{
						j = (guint8) 10;
						break;
					}
					case 'b':
					{
						j = (guint8) 11;
						break;
					}
					case 'c':
					{
						j = (guint8) 12;
						break;
					}
					case 'd':
					{
						j = (guint8) 13;
						break;
					}
					case 'e':
					{
						j = (guint8) 14;
						break;
					}
					case 'f':
					{
						j = (guint8) 15;
						break;
					}
					default:
					{
						result = FALSE;
						if (_result_) {
							*_result_ = _vala_result;
						} else {
							_vala_result = (g_free (_vala_result), NULL);
						}
						if (_result__length1) {
							*_result__length1 = _vala_result_length1;
						}
						return result;
					}
				}
				_tmp30_ = i;
				if ((_tmp30_ % 2) == 0) {
					guint8* _tmp31_;
					gint _tmp31__length1;
					gint _tmp32_;
					guint8 _tmp33_;
					guint8 _tmp34_;
					_tmp31_ = _vala_result;
					_tmp31__length1 = _vala_result_length1;
					_tmp32_ = i;
					_tmp33_ = j;
					_tmp31_[_tmp32_ / 2] += (guint8) (_tmp33_ << 4);
					_tmp34_ = _tmp31_[_tmp32_ / 2];
				} else {
					guint8* _tmp35_;
					gint _tmp35__length1;
					gint _tmp36_;
					guint8 _tmp37_;
					guint8 _tmp38_;
					_tmp35_ = _vala_result;
					_tmp35__length1 = _vala_result_length1;
					_tmp36_ = i;
					_tmp37_ = j;
					_tmp35_[_tmp36_ / 2] += _tmp37_;
					_tmp38_ = _tmp35_[_tmp36_ / 2];
				}
			}
		}
	}
	result = TRUE;
	if (_result_) {
		*_result_ = _vala_result;
	} else {
		_vala_result = (g_free (_vala_result), NULL);
	}
	if (_result__length1) {
		*_result__length1 = _vala_result_length1;
	}
	return result;
}


/**
 * Converts hexadecimal string to int64 value
 * 
 * @param hex          hexadecimal string to convert
 * @param result       converted value
 * @param separator    separator of hexadecimal pairs ('\0' for none)
 * @return             true on success, false on failure (invalid input, overflow)
 */
gboolean drt_hex_to_int64 (const gchar* hex, gint64* _result_, gchar separator) {
	gint64 _vala_result = 0LL;
	gboolean result = FALSE;
	guint8* data = NULL;
	gint data_length1 = 0;
	gint _data_size_ = 0;
	const gchar* _tmp0_;
	gchar _tmp1_;
	guint8* _tmp2_ = NULL;
	gint _tmp3_;
	gboolean _tmp4_;
	gint64 _tmp5_ = 0LL;
	gboolean _tmp6_;
	g_return_val_if_fail (hex != NULL, FALSE);
	_tmp0_ = hex;
	_tmp1_ = separator;
	_tmp4_ = drt_hex_to_bin (_tmp0_, &_tmp2_, &_tmp3_, _tmp1_);
	data = (g_free (data), NULL);
	data = _tmp2_;
	data_length1 = _tmp3_;
	_data_size_ = data_length1;
	g_return_val_if_fail (_tmp4_, FALSE);
	_tmp6_ = drt_bin_to_int64 (data, data_length1, &_tmp5_);
	_vala_result = _tmp5_;
	g_return_val_if_fail (_tmp6_, FALSE);
	result = TRUE;
	data = (g_free (data), NULL);
	if (_result_) {
		*_result_ = _vala_result;
	}
	return result;
}


/**
 * Converts int64 value to hexadecimal string.
 * 
 * @param val        value to convert
 * @param result       converted value
 * @param separator    separator of hexadecimal pairs ('\0' for none)
 */
void drt_int64_to_hex (gint64 val, gchar* * _result_, gchar separator) {
	gchar* _vala_result = NULL;
	guint8* data = NULL;
	gint data_length1 = 0;
	gint _data_size_ = 0;
	gint64 _tmp0_;
	guint8* _tmp1_ = NULL;
	gint _tmp2_;
	gchar _tmp3_;
	gchar* _tmp4_ = NULL;
	_tmp0_ = val;
	drt_int64_to_bin (_tmp0_, &_tmp1_, &_tmp2_);
	data = (g_free (data), NULL);
	data = _tmp1_;
	data_length1 = _tmp2_;
	_data_size_ = data_length1;
	_tmp3_ = separator;
	drt_bin_to_hex (data, data_length1, &_tmp4_, _tmp3_);
	_g_free0 (_vala_result);
	_vala_result = _tmp4_;
	data = (g_free (data), NULL);
	if (_result_) {
		*_result_ = _vala_result;
	} else {
		_g_free0 (_vala_result);
	}
}


/**
 * Converts uint32 value to bytes
 * 
 * @param buffer    buffer of size at least `sizeof(uint32)` where the result will be stored
 * @param data      uint32 value to convert
 * @param offset    offset of the buffer where the result will be stored
 */
void drt_uint32_to_bytes (guint8** buffer, int* buffer_length1, guint32 data, guint offset) {
	gulong size = 0UL;
	guint8* _tmp0_;
	gint _tmp0__length1;
	guint _tmp1_;
	gulong _tmp2_;
	size = sizeof (guint32);
	_tmp0_ = *buffer;
	_tmp0__length1 = *buffer_length1;
	_tmp1_ = offset;
	_tmp2_ = size;
	_vala_assert (((gulong) _tmp0__length1) >= (_tmp1_ + _tmp2_), "buffer.length >= offset + size");
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp3_ = FALSE;
			_tmp3_ = TRUE;
			while (TRUE) {
				gint _tmp5_;
				gulong _tmp6_;
				guint8* _tmp7_;
				gint _tmp7__length1;
				guint _tmp8_;
				gint _tmp9_;
				guint32 _tmp10_;
				gulong _tmp11_;
				gint _tmp12_;
				guint8 _tmp13_;
				if (!_tmp3_) {
					gint _tmp4_;
					_tmp4_ = i;
					i = _tmp4_ + 1;
				}
				_tmp3_ = FALSE;
				_tmp5_ = i;
				_tmp6_ = size;
				if (!(((gulong) _tmp5_) < _tmp6_)) {
					break;
				}
				_tmp7_ = *buffer;
				_tmp7__length1 = *buffer_length1;
				_tmp8_ = offset;
				_tmp9_ = i;
				_tmp10_ = data;
				_tmp11_ = size;
				_tmp12_ = i;
				_tmp7_[_tmp8_ + _tmp9_] = (guint8) ((_tmp10_ >> (((_tmp11_ - 1) - _tmp12_) * 8)) & 0xFF);
				_tmp13_ = _tmp7_[_tmp8_ + _tmp9_];
			}
		}
	}
}


/**
 * Converts int32 value to bytes
 * 
 * @param buffer    buffer of size at least `sizeof(int32)` where the result will be stored
 * @param data      int32 value to convert
 * @param offset    offset of the buffer where the result will be stored
 */
void drt_int32_to_bytes (guint8** buffer, int* buffer_length1, gint32 data, guint offset) {
	gulong size = 0UL;
	guint8* _tmp0_;
	gint _tmp0__length1;
	guint _tmp1_;
	gulong _tmp2_;
	size = sizeof (gint32);
	_tmp0_ = *buffer;
	_tmp0__length1 = *buffer_length1;
	_tmp1_ = offset;
	_tmp2_ = size;
	_vala_assert (((gulong) _tmp0__length1) >= (_tmp1_ + _tmp2_), "buffer.length >= offset + size");
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp3_ = FALSE;
			_tmp3_ = TRUE;
			while (TRUE) {
				gint _tmp5_;
				gulong _tmp6_;
				guint8* _tmp7_;
				gint _tmp7__length1;
				guint _tmp8_;
				gint _tmp9_;
				gint32 _tmp10_;
				gulong _tmp11_;
				gint _tmp12_;
				guint8 _tmp13_;
				if (!_tmp3_) {
					gint _tmp4_;
					_tmp4_ = i;
					i = _tmp4_ + 1;
				}
				_tmp3_ = FALSE;
				_tmp5_ = i;
				_tmp6_ = size;
				if (!(((gulong) _tmp5_) < _tmp6_)) {
					break;
				}
				_tmp7_ = *buffer;
				_tmp7__length1 = *buffer_length1;
				_tmp8_ = offset;
				_tmp9_ = i;
				_tmp10_ = data;
				_tmp11_ = size;
				_tmp12_ = i;
				_tmp7_[_tmp8_ + _tmp9_] = (guint8) ((_tmp10_ >> (((_tmp11_ - 1) - _tmp12_) * 8)) & 0xFF);
				_tmp13_ = _tmp7_[_tmp8_ + _tmp9_];
			}
		}
	}
}


/**
 * Converts bytes to uint32 value
 * 
 * @param buffer    buffer that contains the uint32 value
 * @param data      where the uint32 value will be stored
 * @param offset    offset of the buffer where the uint32 value is located
 */
void drt_uint32_from_bytes (guint8* buffer, int buffer_length1, guint32* data, guint offset) {
	guint32 _vala_data = 0U;
	gulong size = 0UL;
	guint8* _tmp0_;
	gint _tmp0__length1;
	guint _tmp1_;
	gulong _tmp2_;
	size = sizeof (guint32);
	_tmp0_ = buffer;
	_tmp0__length1 = buffer_length1;
	_tmp1_ = offset;
	_tmp2_ = size;
	_vala_assert (((gulong) _tmp0__length1) >= (_tmp1_ + _tmp2_), "buffer.length >= offset + size");
	_vala_data = (guint32) 0;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp3_ = FALSE;
			_tmp3_ = TRUE;
			while (TRUE) {
				gint _tmp5_;
				gulong _tmp6_;
				guint32 _tmp7_;
				guint8* _tmp8_;
				gint _tmp8__length1;
				guint _tmp9_;
				gint _tmp10_;
				guint8 _tmp11_;
				gulong _tmp12_;
				gint _tmp13_;
				if (!_tmp3_) {
					gint _tmp4_;
					_tmp4_ = i;
					i = _tmp4_ + 1;
				}
				_tmp3_ = FALSE;
				_tmp5_ = i;
				_tmp6_ = size;
				if (!(((gulong) _tmp5_) < _tmp6_)) {
					break;
				}
				_tmp7_ = _vala_data;
				_tmp8_ = buffer;
				_tmp8__length1 = buffer_length1;
				_tmp9_ = offset;
				_tmp10_ = i;
				_tmp11_ = _tmp8_[_tmp9_ + _tmp10_];
				_tmp12_ = size;
				_tmp13_ = i;
				_vala_data = _tmp7_ + (_tmp11_ * (1 << (((((guint32) _tmp12_) - 1) - _tmp13_) * 8)));
			}
		}
	}
	if (data) {
		*data = _vala_data;
	}
}


/**
 * Converts bytes to int32 value
 * 
 * @param buffer    buffer that contains the int32 value
 * @param data      where the int32 value will be stored
 * @param offset    offset of the buffer where the int32 value is located
 */
void drt_int32_from_bytes (guint8* buffer, int buffer_length1, gint32* data, guint offset) {
	gint32 _vala_data = 0;
	gulong size = 0UL;
	guint8* _tmp0_;
	gint _tmp0__length1;
	guint _tmp1_;
	gulong _tmp2_;
	size = sizeof (gint32);
	_tmp0_ = buffer;
	_tmp0__length1 = buffer_length1;
	_tmp1_ = offset;
	_tmp2_ = size;
	_vala_assert (((gulong) _tmp0__length1) >= (_tmp1_ + _tmp2_), "buffer.length >= offset + size");
	_vala_data = (gint32) 0;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp3_ = FALSE;
			_tmp3_ = TRUE;
			while (TRUE) {
				gint _tmp5_;
				gulong _tmp6_;
				gint32 _tmp7_;
				guint8* _tmp8_;
				gint _tmp8__length1;
				guint _tmp9_;
				gint _tmp10_;
				guint8 _tmp11_;
				gulong _tmp12_;
				gint _tmp13_;
				if (!_tmp3_) {
					gint _tmp4_;
					_tmp4_ = i;
					i = _tmp4_ + 1;
				}
				_tmp3_ = FALSE;
				_tmp5_ = i;
				_tmp6_ = size;
				if (!(((gulong) _tmp5_) < _tmp6_)) {
					break;
				}
				_tmp7_ = _vala_data;
				_tmp8_ = buffer;
				_tmp8__length1 = buffer_length1;
				_tmp9_ = offset;
				_tmp10_ = i;
				_tmp11_ = _tmp8_[_tmp9_ + _tmp10_];
				_tmp12_ = size;
				_tmp13_ = i;
				_vala_data = _tmp7_ + (_tmp11_ * (1 << (((((gint32) _tmp12_) - 1) - _tmp13_) * 8)));
			}
		}
	}
	if (data) {
		*data = _vala_data;
	}
}



