/* Event.c generated by valac 0.38.10, the Vala compiler
 * generated from Event.vala, do not modify */

/*
 * Copyright 2018 Jiří Janoušek <janousek.jiri@gmail.com>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <glib.h>
#include <glib-object.h>
#include <string.h>
#include <gobject/gvaluecollector.h>


#define DRT_TYPE_EVENT (drt_event_get_type ())
#define DRT_EVENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DRT_TYPE_EVENT, DrtEvent))
#define DRT_EVENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DRT_TYPE_EVENT, DrtEventClass))
#define DRT_IS_EVENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DRT_TYPE_EVENT))
#define DRT_IS_EVENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DRT_TYPE_EVENT))
#define DRT_EVENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DRT_TYPE_EVENT, DrtEventClass))

typedef struct _DrtEvent DrtEvent;
typedef struct _DrtEventClass DrtEventClass;
typedef struct _DrtEventPrivate DrtEventPrivate;
typedef struct _DrtParamSpecEvent DrtParamSpecEvent;

struct _DrtEvent {
	GTypeInstance parent_instance;
	volatile int ref_count;
	DrtEventPrivate * priv;
};

struct _DrtEventClass {
	GTypeClass parent_class;
	void (*finalize) (DrtEvent *self);
};

struct _DrtEventPrivate {
	gboolean flag;
	GMutex mutex;
	GCond condition;
};

struct _DrtParamSpecEvent {
	GParamSpec parent_instance;
};


static gpointer drt_event_parent_class = NULL;

gpointer drt_event_ref (gpointer instance);
void drt_event_unref (gpointer instance);
GParamSpec* drt_param_spec_event (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void drt_value_set_event (GValue* value, gpointer v_object);
void drt_value_take_event (GValue* value, gpointer v_object);
gpointer drt_value_get_event (const GValue* value);
GType drt_event_get_type (void) G_GNUC_CONST;
#define DRT_EVENT_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), DRT_TYPE_EVENT, DrtEventPrivate))
DrtEvent* drt_event_new (gboolean is_set);
DrtEvent* drt_event_construct (GType object_type, gboolean is_set);
gboolean drt_event_is_set (DrtEvent* self);
void drt_event_wait (DrtEvent* self);
gboolean drt_event_wait_until (DrtEvent* self, gint64 end_time);
gboolean drt_event_wait_for (DrtEvent* self, gint64 microseconds);
void drt_event_set (DrtEvent* self);
void drt_event_clear (DrtEvent* self);
static void drt_event_finalize (DrtEvent * obj);
static void _vala_clear_GMutex (GMutex * mutex);
static void _vala_clear_GRecMutex (GRecMutex * mutex);
static void _vala_clear_GRWLock (GRWLock * mutex);
static void _vala_clear_GCond (GCond * mutex);


DrtEvent* drt_event_construct (GType object_type, gboolean is_set) {
	DrtEvent* self = NULL;
	gboolean _tmp0_;
	self = (DrtEvent*) g_type_create_instance (object_type);
	_tmp0_ = is_set;
	self->priv->flag = _tmp0_;
	return self;
}


DrtEvent* drt_event_new (gboolean is_set) {
	return drt_event_construct (DRT_TYPE_EVENT, is_set);
}


gboolean drt_event_is_set (DrtEvent* self) {
	gboolean result = FALSE;
	gboolean _result_ = FALSE;
	gboolean _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	g_mutex_lock (&self->priv->mutex);
	_tmp0_ = self->priv->flag;
	_result_ = _tmp0_;
	g_mutex_unlock (&self->priv->mutex);
	result = _result_;
	return result;
}


void drt_event_wait (DrtEvent* self) {
	g_return_if_fail (self != NULL);
	g_mutex_lock (&self->priv->mutex);
	while (TRUE) {
		gboolean _tmp0_;
		_tmp0_ = self->priv->flag;
		if (!(!_tmp0_)) {
			break;
		}
		g_cond_wait (&self->priv->condition, &self->priv->mutex);
	}
	g_mutex_unlock (&self->priv->mutex);
}


gboolean drt_event_wait_until (DrtEvent* self, gint64 end_time) {
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_mutex_lock (&self->priv->mutex);
	while (TRUE) {
		gboolean _tmp0_;
		gint64 _tmp1_;
		gboolean _tmp2_;
		_tmp0_ = self->priv->flag;
		if (!(!_tmp0_)) {
			break;
		}
		_tmp1_ = end_time;
		_tmp2_ = g_cond_wait_until (&self->priv->condition, &self->priv->mutex, _tmp1_);
		if (!_tmp2_) {
			g_mutex_unlock (&self->priv->mutex);
			result = FALSE;
			return result;
		}
	}
	g_mutex_unlock (&self->priv->mutex);
	result = TRUE;
	return result;
}


gboolean drt_event_wait_for (DrtEvent* self, gint64 microseconds) {
	gboolean result = FALSE;
	gint64 _tmp0_;
	gint64 _tmp1_;
	gboolean _tmp2_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = g_get_monotonic_time ();
	_tmp1_ = microseconds;
	_tmp2_ = drt_event_wait_until (self, _tmp0_ + _tmp1_);
	result = _tmp2_;
	return result;
}


void drt_event_set (DrtEvent* self) {
	gboolean _tmp0_;
	g_return_if_fail (self != NULL);
	g_mutex_lock (&self->priv->mutex);
	_tmp0_ = self->priv->flag;
	if (!_tmp0_) {
		self->priv->flag = TRUE;
		g_cond_broadcast (&self->priv->condition);
	}
	g_mutex_unlock (&self->priv->mutex);
}


void drt_event_clear (DrtEvent* self) {
	g_return_if_fail (self != NULL);
	g_mutex_lock (&self->priv->mutex);
	self->priv->flag = FALSE;
	g_mutex_unlock (&self->priv->mutex);
}


static void drt_value_event_init (GValue* value) {
	value->data[0].v_pointer = NULL;
}


static void drt_value_event_free_value (GValue* value) {
	if (value->data[0].v_pointer) {
		drt_event_unref (value->data[0].v_pointer);
	}
}


static void drt_value_event_copy_value (const GValue* src_value, GValue* dest_value) {
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = drt_event_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer drt_value_event_peek_pointer (const GValue* value) {
	return value->data[0].v_pointer;
}


static gchar* drt_value_event_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	if (collect_values[0].v_pointer) {
		DrtEvent * object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = drt_event_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar* drt_value_event_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	DrtEvent ** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = drt_event_ref (value->data[0].v_pointer);
	}
	return NULL;
}


GParamSpec* drt_param_spec_event (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	DrtParamSpecEvent* spec;
	g_return_val_if_fail (g_type_is_a (object_type, DRT_TYPE_EVENT), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


gpointer drt_value_get_event (const GValue* value) {
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, DRT_TYPE_EVENT), NULL);
	return value->data[0].v_pointer;
}


void drt_value_set_event (GValue* value, gpointer v_object) {
	DrtEvent * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, DRT_TYPE_EVENT));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, DRT_TYPE_EVENT));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		drt_event_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		drt_event_unref (old);
	}
}


void drt_value_take_event (GValue* value, gpointer v_object) {
	DrtEvent * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, DRT_TYPE_EVENT));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, DRT_TYPE_EVENT));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		drt_event_unref (old);
	}
}


static void drt_event_class_init (DrtEventClass * klass) {
	drt_event_parent_class = g_type_class_peek_parent (klass);
	((DrtEventClass *) klass)->finalize = drt_event_finalize;
	g_type_class_add_private (klass, sizeof (DrtEventPrivate));
}


static void drt_event_instance_init (DrtEvent * self) {
	self->priv = DRT_EVENT_GET_PRIVATE (self);
	self->priv->flag = FALSE;
	g_mutex_init (&self->priv->mutex);
	g_cond_init (&self->priv->condition);
	self->ref_count = 1;
}


static void drt_event_finalize (DrtEvent * obj) {
	DrtEvent * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DRT_TYPE_EVENT, DrtEvent);
	g_signal_handlers_destroy (self);
	_vala_clear_GMutex (&self->priv->mutex);
	_vala_clear_GCond (&self->priv->condition);
}


GType drt_event_get_type (void) {
	static volatile gsize drt_event_type_id__volatile = 0;
	if (g_once_init_enter (&drt_event_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { drt_value_event_init, drt_value_event_free_value, drt_value_event_copy_value, drt_value_event_peek_pointer, "p", drt_value_event_collect_value, "p", drt_value_event_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (DrtEventClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) drt_event_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DrtEvent), 0, (GInstanceInitFunc) drt_event_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType drt_event_type_id;
		drt_event_type_id = g_type_register_fundamental (g_type_fundamental_next (), "DrtEvent", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&drt_event_type_id__volatile, drt_event_type_id);
	}
	return drt_event_type_id__volatile;
}


gpointer drt_event_ref (gpointer instance) {
	DrtEvent * self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


void drt_event_unref (gpointer instance) {
	DrtEvent * self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		DRT_EVENT_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}


static void _vala_clear_GMutex (GMutex * mutex) {
	GMutex zero_mutex = { 0 };
	if (memcmp (mutex, &zero_mutex, sizeof (GMutex))) {
		g_mutex_clear (mutex);
		memset (mutex, 0, sizeof (GMutex));
	}
}


static void _vala_clear_GRecMutex (GRecMutex * mutex) {
	GRecMutex zero_mutex = { 0 };
	if (memcmp (mutex, &zero_mutex, sizeof (GRecMutex))) {
		g_rec_mutex_clear (mutex);
		memset (mutex, 0, sizeof (GRecMutex));
	}
}


static void _vala_clear_GRWLock (GRWLock * mutex) {
	GRWLock zero_mutex = { 0 };
	if (memcmp (mutex, &zero_mutex, sizeof (GRWLock))) {
		g_rw_lock_clear (mutex);
		memset (mutex, 0, sizeof (GRWLock));
	}
}


static void _vala_clear_GCond (GCond * mutex) {
	GCond zero_mutex = { 0 };
	if (memcmp (mutex, &zero_mutex, sizeof (GCond))) {
		g_cond_clear (mutex);
		memset (mutex, 0, sizeof (GCond));
	}
}



