/* Logger.c generated by valac 0.38.10, the Vala compiler
 * generated from Logger.vala, do not modify */

/*
 * Copyright 2011-2014 Jiří Janoušek <janousek.jiri@gmail.com>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met: 
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <unistd.h>
#include <stdarg.h>
#include <gobject/gvaluecollector.h>


#define DRT_TYPE_LOGGER (drt_logger_get_type ())
#define DRT_LOGGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DRT_TYPE_LOGGER, DrtLogger))
#define DRT_LOGGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DRT_TYPE_LOGGER, DrtLoggerClass))
#define DRT_IS_LOGGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DRT_TYPE_LOGGER))
#define DRT_IS_LOGGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DRT_TYPE_LOGGER))
#define DRT_LOGGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DRT_TYPE_LOGGER, DrtLoggerClass))

typedef struct _DrtLogger DrtLogger;
typedef struct _DrtLoggerClass DrtLoggerClass;
typedef struct _DrtLoggerPrivate DrtLoggerPrivate;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define _g_pattern_spec_free0(var) ((var == NULL) ? NULL : (var = (g_pattern_spec_free (var), NULL)))
typedef struct _DrtParamSpecLogger DrtParamSpecLogger;

struct _DrtLogger {
	GTypeInstance parent_instance;
	volatile int ref_count;
	DrtLoggerPrivate * priv;
};

struct _DrtLoggerClass {
	GTypeClass parent_class;
	void (*finalize) (DrtLogger *self);
};

struct _DrtParamSpecLogger {
	GParamSpec parent_instance;
};


static gpointer drt_logger_parent_class = NULL;
static GLogLevelFlags drt_logger_display_level;
static GLogLevelFlags drt_logger_display_level = 0;
static FILE* drt_logger_output;
static GRecMutex __lock_drt_logger_drt_logger_output = {0};
static FILE* drt_logger_output = NULL;
static gboolean drt_logger_colorful;
static gboolean drt_logger_colorful = FALSE;
static gchar* drt_logger_hint;
static gchar* drt_logger_hint = NULL;
static GDateTime* drt_logger_time_ref;
static GRecMutex __lock_drt_logger_drt_logger_time_ref = {0};
static GDateTime* drt_logger_time_ref = NULL;
static GPatternSpec* drt_logger_fatal_string;
static GPatternSpec* drt_logger_fatal_string = NULL;

#define G_LOG_DOMAIN "DioriteGlib"
gpointer drt_logger_ref (gpointer instance);
void drt_logger_unref (gpointer instance);
GParamSpec* drt_param_spec_logger (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void drt_value_set_logger (GValue* value, gpointer v_object);
void drt_value_take_logger (GValue* value, gpointer v_object);
gpointer drt_value_get_logger (const GValue* value);
GType drt_logger_get_type (void) G_GNUC_CONST;
#define DRT_LOGGER_COLOR_FOREGROUND 30
#define DRT_LOGGER_COLOR_BACKGROUND 40
#define DRT_LOGGER_COLOR_BLACK 0
#define DRT_LOGGER_COLOR_RED 1
#define DRT_LOGGER_COLOR_GREEN 2
#define DRT_LOGGER_COLOR_YELLOW 3
#define DRT_LOGGER_COLOR_BLUE 4
#define DRT_LOGGER_COLOR_MAGENTA 5
#define DRT_LOGGER_COLOR_CYAN 6
#define DRT_LOGGER_COLOR_WHITE 7
void drt_logger_init_stderr (GLogLevelFlags display_level, gboolean time, const gchar* hint);
void drt_logger_init (FILE* output, GLogLevelFlags display_level, gboolean time, const gchar* hint);
gboolean drt_logger_colors_supported (void);
static void drt_logger_log_handler (const gchar* domain, GLogLevelFlags level, const gchar* message);
static void _drt_logger_log_handler_glog_func (const gchar* log_domain, GLogLevelFlags log_levels, const gchar* message, gpointer self);
void drt_logger_printf (const gchar* format, ...) G_GNUC_PRINTF(1,2);
void drt_logger_puts (const gchar* line);
void drt_logger_logf (const gchar* format, ...) G_GNUC_PRINTF(1,2);
void drt_logger_log (const gchar* line);
static void drt_logger_print (const gchar* domain, GLogLevelFlags level, const gchar* message);
DrtLogger* drt_logger_new (void);
DrtLogger* drt_logger_construct (GType object_type);
static void drt_logger_finalize (DrtLogger * obj);


void drt_logger_init_stderr (GLogLevelFlags display_level, gboolean time, const gchar* hint) {
	FILE* _tmp0_;
	GLogLevelFlags _tmp1_;
	gboolean _tmp2_;
	const gchar* _tmp3_;
	_tmp0_ = stderr;
	_tmp1_ = display_level;
	_tmp2_ = time;
	_tmp3_ = hint;
	drt_logger_init (_tmp0_, _tmp1_, _tmp2_, _tmp3_);
}


/**
 * Initializes new logger for GLib
 * 
 * @param output           output to write logger messages to (e. g. sys.stderr)
 * @param display_level    lowest log level to log
 */
static gpointer _g_date_time_ref0 (gpointer self) {
	return self ? g_date_time_ref (self) : NULL;
}


static gchar string_get (const gchar* self, glong index) {
	gchar result = '\0';
	glong _tmp0_;
	gchar _tmp1_;
	g_return_val_if_fail (self != NULL, '\0');
	_tmp0_ = index;
	_tmp1_ = ((gchar*) self)[_tmp0_];
	result = _tmp1_;
	return result;
}


static void _drt_logger_log_handler_glog_func (const gchar* log_domain, GLogLevelFlags log_levels, const gchar* message, gpointer self) {
	drt_logger_log_handler (log_domain, log_levels, message);
}


void drt_logger_init (FILE* output, GLogLevelFlags display_level, gboolean time, const gchar* hint) {
	FILE* _tmp0_;
	GLogLevelFlags _tmp1_;
	gchar* _tmp2_ = NULL;
	const gchar* _tmp3_;
	gchar* _tmp6_;
	gchar* use_colors = NULL;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	const gchar* _tmp9_;
	GDateTime* _tmp14_ = NULL;
	gboolean _tmp15_;
	GDateTime* _tmp17_;
	gchar* fatal_string = NULL;
	const gchar* _tmp18_;
	gchar* _tmp19_;
	gboolean _tmp20_ = FALSE;
	const gchar* _tmp21_;
	g_return_if_fail (output != NULL);
	_tmp0_ = output;
	drt_logger_output = _tmp0_;
	_tmp1_ = display_level;
	drt_logger_display_level = _tmp1_;
	_tmp3_ = hint;
	if (_tmp3_ != NULL) {
		const gchar* _tmp4_;
		gchar* _tmp5_;
		_tmp4_ = hint;
		_tmp5_ = g_strconcat (_tmp4_, ": ", NULL);
		_g_free0 (_tmp2_);
		_tmp2_ = _tmp5_;
	} else {
		_g_free0 (_tmp2_);
		_tmp2_ = NULL;
	}
	_tmp6_ = g_strdup (_tmp2_);
	_g_free0 (drt_logger_hint);
	drt_logger_hint = _tmp6_;
	_tmp7_ = g_getenv ("DIORITE_LOGGER_USE_COLORS");
	_tmp8_ = g_strdup (_tmp7_);
	use_colors = _tmp8_;
	_tmp9_ = use_colors;
	if (g_strcmp0 (_tmp9_, "yes") == 0) {
		drt_logger_colorful = TRUE;
	} else {
		const gchar* _tmp10_;
		_tmp10_ = use_colors;
		if (g_strcmp0 (_tmp10_, "no") == 0) {
			drt_logger_colorful = FALSE;
		} else {
			gboolean _tmp11_;
			const gchar* _tmp12_ = NULL;
			gboolean _tmp13_;
			_tmp11_ = drt_logger_colors_supported ();
			drt_logger_colorful = _tmp11_;
			_tmp13_ = drt_logger_colorful;
			if (_tmp13_) {
				_tmp12_ = "yes";
			} else {
				_tmp12_ = "no";
			}
			g_setenv ("DIORITE_LOGGER_USE_COLORS", _tmp12_, FALSE);
		}
	}
	_tmp15_ = time;
	if (_tmp15_) {
		GDateTime* _tmp16_;
		_tmp16_ = g_date_time_new_now_local ();
		_g_date_time_unref0 (_tmp14_);
		_tmp14_ = _tmp16_;
	} else {
		_g_date_time_unref0 (_tmp14_);
		_tmp14_ = NULL;
	}
	_tmp17_ = _g_date_time_ref0 (_tmp14_);
	_g_date_time_unref0 (drt_logger_time_ref);
	drt_logger_time_ref = _tmp17_;
	_tmp18_ = g_getenv ("DIORITE_LOGGER_FATAL_STRING");
	_tmp19_ = g_strdup (_tmp18_);
	fatal_string = _tmp19_;
	_tmp21_ = fatal_string;
	if (_tmp21_ != NULL) {
		const gchar* _tmp22_;
		gchar _tmp23_;
		_tmp22_ = fatal_string;
		_tmp23_ = string_get (_tmp22_, (glong) 0);
		_tmp20_ = _tmp23_ != '\0';
	} else {
		_tmp20_ = FALSE;
	}
	if (_tmp20_) {
		const gchar* _tmp24_;
		GPatternSpec* _tmp25_;
		_tmp24_ = fatal_string;
		_tmp25_ = g_pattern_spec_new (_tmp24_);
		_g_pattern_spec_free0 (drt_logger_fatal_string);
		drt_logger_fatal_string = _tmp25_;
	}
	g_log_set_default_handler (_drt_logger_log_handler_glog_func, NULL);
	_g_free0 (fatal_string);
	_g_date_time_unref0 (_tmp14_);
	_g_free0 (use_colors);
	_g_free0 (_tmp2_);
}


gboolean drt_logger_colors_supported (void) {
	gboolean result = FALSE;
	FILE* _tmp0_;
	gint _tmp1_;
	gboolean _tmp2_;
	_tmp0_ = drt_logger_output;
	_tmp1_ = fileno (_tmp0_);
	_tmp2_ = isatty (_tmp1_);
	result = _tmp2_;
	return result;
}


/**
 * Prints message to log without any hint
 * 
 * @param format    message format
 */
void drt_logger_printf (const gchar* format, ...) {
	GError * _inner_error_ = NULL;
	g_return_if_fail (format != NULL);
	{
		FILE* _tmp0_;
		_tmp0_ = drt_logger_output;
		g_rec_mutex_lock (&__lock_drt_logger_drt_logger_output);
		{
			FILE* _tmp1_;
			const gchar* _tmp2_;
			va_list _tmp3_ = {0};
			FILE* _tmp4_;
			_tmp1_ = drt_logger_output;
			_tmp2_ = format;
			va_start (_tmp3_, format);
			vfprintf (_tmp1_, _tmp2_, _tmp3_);
			va_end (_tmp3_);
			_tmp4_ = drt_logger_output;
			fflush (_tmp4_);
		}
		__finally42:
		{
			FILE* _tmp5_;
			_tmp5_ = drt_logger_output;
			g_rec_mutex_unlock (&__lock_drt_logger_drt_logger_output);
		}
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
}


/**
 * Prints line to log without any hint
 * 
 * @param line    line to log
 */
void drt_logger_puts (const gchar* line) {
	GError * _inner_error_ = NULL;
	g_return_if_fail (line != NULL);
	{
		FILE* _tmp0_;
		_tmp0_ = drt_logger_output;
		g_rec_mutex_lock (&__lock_drt_logger_drt_logger_output);
		{
			FILE* _tmp1_;
			const gchar* _tmp2_;
			FILE* _tmp3_;
			_tmp1_ = drt_logger_output;
			_tmp2_ = line;
			fputs (_tmp2_, _tmp1_);
			_tmp3_ = drt_logger_output;
			fflush (_tmp3_);
		}
		__finally43:
		{
			FILE* _tmp4_;
			_tmp4_ = drt_logger_output;
			g_rec_mutex_unlock (&__lock_drt_logger_drt_logger_output);
		}
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
}


/**
 * Prints message to log with hint if specified
 * 
 * @param format    message format
 */
void drt_logger_logf (const gchar* format, ...) {
	GError * _inner_error_ = NULL;
	g_return_if_fail (format != NULL);
	{
		FILE* _tmp0_;
		_tmp0_ = drt_logger_output;
		g_rec_mutex_lock (&__lock_drt_logger_drt_logger_output);
		{
			const gchar* _tmp1_;
			FILE* _tmp5_;
			const gchar* _tmp6_;
			va_list _tmp7_ = {0};
			FILE* _tmp8_;
			_tmp1_ = drt_logger_hint;
			if (_tmp1_ != NULL) {
				FILE* _tmp2_;
				const gchar* _tmp3_;
				FILE* _tmp4_;
				_tmp2_ = drt_logger_output;
				_tmp3_ = drt_logger_hint;
				fputs (_tmp3_, _tmp2_);
				_tmp4_ = drt_logger_output;
				fputc (' ', _tmp4_);
			}
			_tmp5_ = drt_logger_output;
			_tmp6_ = format;
			va_start (_tmp7_, format);
			vfprintf (_tmp5_, _tmp6_, _tmp7_);
			va_end (_tmp7_);
			_tmp8_ = drt_logger_output;
			fflush (_tmp8_);
		}
		__finally44:
		{
			FILE* _tmp9_;
			_tmp9_ = drt_logger_output;
			g_rec_mutex_unlock (&__lock_drt_logger_drt_logger_output);
		}
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
}


/**
 * Prints line to log with hint if specified
 * 
 * @param line    line to log
 */
void drt_logger_log (const gchar* line) {
	GError * _inner_error_ = NULL;
	g_return_if_fail (line != NULL);
	{
		FILE* _tmp0_;
		_tmp0_ = drt_logger_output;
		g_rec_mutex_lock (&__lock_drt_logger_drt_logger_output);
		{
			const gchar* _tmp1_;
			FILE* _tmp5_;
			const gchar* _tmp6_;
			FILE* _tmp7_;
			_tmp1_ = drt_logger_hint;
			if (_tmp1_ != NULL) {
				FILE* _tmp2_;
				const gchar* _tmp3_;
				FILE* _tmp4_;
				_tmp2_ = drt_logger_output;
				_tmp3_ = drt_logger_hint;
				fputs (_tmp3_, _tmp2_);
				_tmp4_ = drt_logger_output;
				fputc (' ', _tmp4_);
			}
			_tmp5_ = drt_logger_output;
			_tmp6_ = line;
			fputs (_tmp6_, _tmp5_);
			_tmp7_ = drt_logger_output;
			fflush (_tmp7_);
		}
		__finally45:
		{
			FILE* _tmp8_;
			_tmp8_ = drt_logger_output;
			g_rec_mutex_unlock (&__lock_drt_logger_drt_logger_output);
		}
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
}


static void drt_logger_log_handler (const gchar* domain, GLogLevelFlags level, const gchar* message) {
	gboolean _tmp0_ = FALSE;
	GPatternSpec* _tmp1_;
	gboolean is_fatal_string = FALSE;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp6_;
	const gchar* _tmp9_ = NULL;
	const gchar* _tmp10_;
	GLogLevelFlags _tmp11_;
	const gchar* _tmp12_;
	GLogLevelFlags _tmp13_;
	gboolean _tmp20_;
	g_return_if_fail (message != NULL);
	_tmp1_ = drt_logger_fatal_string;
	if (_tmp1_ != NULL) {
		GPatternSpec* _tmp2_;
		const gchar* _tmp3_;
		gboolean _tmp4_;
		_tmp2_ = drt_logger_fatal_string;
		_tmp3_ = message;
		_tmp4_ = g_pattern_match_string (_tmp2_, _tmp3_);
		_tmp0_ = _tmp4_;
	} else {
		_tmp0_ = FALSE;
	}
	is_fatal_string = _tmp0_;
	_tmp6_ = is_fatal_string;
	if (!_tmp6_) {
		GLogLevelFlags _tmp7_;
		GLogLevelFlags _tmp8_;
		_tmp7_ = level;
		_tmp8_ = drt_logger_display_level;
		_tmp5_ = _tmp7_ > _tmp8_;
	} else {
		_tmp5_ = FALSE;
	}
	if (_tmp5_) {
		return;
	}
	_tmp10_ = domain;
	_tmp9_ = _tmp10_;
	if (_tmp9_ == NULL) {
		_tmp9_ = "<unknown>";
	}
	_tmp11_ = level;
	_tmp12_ = message;
	drt_logger_print (_tmp9_, _tmp11_, _tmp12_);
	_tmp13_ = level;
	switch ((gint) _tmp13_) {
		case G_LOG_LEVEL_ERROR:
		case 6:
		{
			const gchar* _tmp14_ = NULL;
			const gchar* _tmp15_;
			GLogLevelFlags _tmp16_;
			_tmp15_ = domain;
			_tmp14_ = _tmp15_;
			if (_tmp14_ == NULL) {
				_tmp14_ = "<unknown>";
			}
			_tmp16_ = level;
			drt_logger_print (_tmp14_, _tmp16_, "Application will be terminated.");
			break;
		}
		case G_LOG_LEVEL_CRITICAL:
		{
			const gchar* _tmp17_ = NULL;
			const gchar* _tmp18_;
			GLogLevelFlags _tmp19_;
			_tmp18_ = domain;
			_tmp17_ = _tmp18_;
			if (_tmp17_ == NULL) {
				_tmp17_ = "<unknown>";
			}
			_tmp19_ = level;
			drt_logger_print (_tmp17_, _tmp19_, "Application will not function properly.");
			break;
		}
		default:
		break;
	}
	_tmp20_ = is_fatal_string;
	if (_tmp20_) {
		const gchar* _tmp21_ = NULL;
		const gchar* _tmp22_;
		_tmp22_ = domain;
		_tmp21_ = _tmp22_;
		if (_tmp21_ == NULL) {
			_tmp21_ = "<unknown>";
		}
		drt_logger_print (_tmp21_, G_LOG_LEVEL_ERROR, "Will abort because of fatal string match.");
		abort ();
	}
}


static void drt_logger_print (const gchar* domain, GLogLevelFlags level, const gchar* message) {
	gchar* name = NULL;
	gchar* _tmp0_;
	gint color = 0;
	GLogLevelFlags _tmp1_;
	const gchar* _tmp11_ = NULL;
	const gchar* _tmp12_;
	gchar* hint = NULL;
	gchar* _tmp13_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (domain != NULL);
	g_return_if_fail (message != NULL);
	_tmp0_ = g_strdup ("");
	name = _tmp0_;
	color = -1;
	_tmp1_ = level;
	switch ((gint) _tmp1_) {
		case G_LOG_LEVEL_CRITICAL:
		{
			gchar* _tmp2_;
			_tmp2_ = g_strdup ("CRITICAL");
			_g_free0 (name);
			name = _tmp2_;
			color = DRT_LOGGER_COLOR_RED;
			break;
		}
		case G_LOG_LEVEL_ERROR:
		case 6:
		{
			gchar* _tmp3_;
			_tmp3_ = g_strdup ("ERROR");
			_g_free0 (name);
			name = _tmp3_;
			color = DRT_LOGGER_COLOR_RED;
			break;
		}
		case G_LOG_LEVEL_WARNING:
		{
			gchar* _tmp4_;
			_tmp4_ = g_strdup ("WARNING");
			_g_free0 (name);
			name = _tmp4_;
			color = DRT_LOGGER_COLOR_YELLOW;
			break;
		}
		case G_LOG_LEVEL_MESSAGE:
		case G_LOG_LEVEL_INFO:
		{
			gchar* _tmp5_;
			_tmp5_ = g_strdup ("INFO");
			_g_free0 (name);
			name = _tmp5_;
			color = DRT_LOGGER_COLOR_GREEN;
			break;
		}
		case G_LOG_LEVEL_DEBUG:
		{
			gchar* _tmp6_;
			_tmp6_ = g_strdup ("DEBUG");
			_g_free0 (name);
			name = _tmp6_;
			color = DRT_LOGGER_COLOR_BLUE;
			break;
		}
		case G_LOG_LEVEL_MASK:
		{
			gchar* _tmp7_;
			_tmp7_ = g_strdup ("MASK");
			_g_free0 (name);
			name = _tmp7_;
			break;
		}
		case G_LOG_FLAG_RECURSION:
		{
			gchar* _tmp8_;
			_tmp8_ = g_strdup ("Recursion");
			_g_free0 (name);
			name = _tmp8_;
			break;
		}
		case G_LOG_FLAG_FATAL:
		{
			gchar* _tmp9_;
			_tmp9_ = g_strdup ("Fatal");
			_g_free0 (name);
			name = _tmp9_;
			break;
		}
		default:
		{
			gchar* _tmp10_;
			_tmp10_ = g_strdup ("Unknown");
			_g_free0 (name);
			name = _tmp10_;
			break;
		}
	}
	_tmp12_ = drt_logger_hint;
	_tmp11_ = _tmp12_;
	if (_tmp11_ == NULL) {
		_tmp11_ = "";
	}
	_tmp13_ = g_strdup (_tmp11_);
	hint = _tmp13_;
	{
		FILE* _tmp14_;
		_tmp14_ = drt_logger_output;
		g_rec_mutex_lock (&__lock_drt_logger_drt_logger_output);
		{
			GDateTime* _tmp15_;
			gboolean _tmp59_ = FALSE;
			gboolean _tmp60_;
			FILE* _tmp73_;
			_tmp15_ = drt_logger_time_ref;
			if (_tmp15_ != NULL) {
				GDateTime* now = NULL;
				GDateTime* _tmp16_;
				GTimeSpan diff = 0LL;
				const gchar* _tmp25_;
				gchar* _tmp26_;
				GTimeSpan hours = 0LL;
				GTimeSpan _tmp27_;
				GTimeSpan _tmp28_;
				GTimeSpan minutes = 0LL;
				GTimeSpan _tmp36_;
				GTimeSpan _tmp37_;
				GTimeSpan seconds = 0LL;
				GTimeSpan _tmp45_;
				GTimeSpan _tmp46_;
				const gchar* _tmp54_;
				GTimeSpan _tmp55_;
				gchar* _tmp56_;
				gchar* _tmp57_;
				gchar* _tmp58_;
				_tmp16_ = g_date_time_new_now_local ();
				now = _tmp16_;
				{
					GDateTime* _tmp17_;
					_tmp17_ = drt_logger_time_ref;
					g_rec_mutex_lock (&__lock_drt_logger_drt_logger_time_ref);
					{
						GDateTime* _tmp18_;
						GDateTime* _tmp19_;
						GTimeSpan _tmp20_;
						GDateTime* _tmp21_;
						GDateTime* _tmp22_;
						_tmp18_ = now;
						_tmp19_ = drt_logger_time_ref;
						_tmp20_ = g_date_time_difference (_tmp18_, _tmp19_);
						diff = _tmp20_;
						_tmp21_ = now;
						_tmp22_ = _g_date_time_ref0 (_tmp21_);
						_g_date_time_unref0 (drt_logger_time_ref);
						drt_logger_time_ref = _tmp22_;
					}
					__finally47:
					{
						GDateTime* _tmp23_;
						_tmp23_ = drt_logger_time_ref;
						g_rec_mutex_unlock (&__lock_drt_logger_drt_logger_time_ref);
					}
					if (G_UNLIKELY (_inner_error_ != NULL)) {
						_g_date_time_unref0 (now);
						_g_date_time_unref0 (now);
						{
							FILE* _tmp24_;
							_tmp24_ = drt_logger_output;
							g_rec_mutex_unlock (&__lock_drt_logger_drt_logger_output);
						}
						_g_free0 (hint);
						_g_free0 (name);
						g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
						g_clear_error (&_inner_error_);
						return;
					}
				}
				_tmp25_ = name;
				_tmp26_ = g_strconcat (_tmp25_, " Δ", NULL);
				_g_free0 (name);
				name = _tmp26_;
				_tmp27_ = diff;
				hours = _tmp27_ / G_TIME_SPAN_HOUR;
				_tmp28_ = hours;
				if (_tmp28_ > ((GTimeSpan) 0)) {
					GTimeSpan _tmp29_;
					GTimeSpan _tmp30_;
					const gchar* _tmp31_;
					GTimeSpan _tmp32_;
					gchar* _tmp33_;
					gchar* _tmp34_;
					gchar* _tmp35_;
					_tmp29_ = diff;
					_tmp30_ = hours;
					diff = _tmp29_ - (_tmp30_ * G_TIME_SPAN_HOUR);
					_tmp31_ = name;
					_tmp32_ = hours;
					_tmp33_ = g_strdup_printf ("%dh", (gint) _tmp32_);
					_tmp34_ = _tmp33_;
					_tmp35_ = g_strconcat (_tmp31_, _tmp34_, NULL);
					_g_free0 (name);
					name = _tmp35_;
					_g_free0 (_tmp34_);
				}
				_tmp36_ = diff;
				minutes = _tmp36_ / G_TIME_SPAN_MINUTE;
				_tmp37_ = minutes;
				if (_tmp37_ > ((GTimeSpan) 0)) {
					GTimeSpan _tmp38_;
					GTimeSpan _tmp39_;
					const gchar* _tmp40_;
					GTimeSpan _tmp41_;
					gchar* _tmp42_;
					gchar* _tmp43_;
					gchar* _tmp44_;
					_tmp38_ = diff;
					_tmp39_ = minutes;
					diff = _tmp38_ - (_tmp39_ * G_TIME_SPAN_MINUTE);
					_tmp40_ = name;
					_tmp41_ = minutes;
					_tmp42_ = g_strdup_printf ("%02dm", (gint) _tmp41_);
					_tmp43_ = _tmp42_;
					_tmp44_ = g_strconcat (_tmp40_, _tmp43_, NULL);
					_g_free0 (name);
					name = _tmp44_;
					_g_free0 (_tmp43_);
				}
				_tmp45_ = diff;
				seconds = _tmp45_ / G_TIME_SPAN_SECOND;
				_tmp46_ = seconds;
				if (_tmp46_ > ((GTimeSpan) 0)) {
					GTimeSpan _tmp47_;
					GTimeSpan _tmp48_;
					const gchar* _tmp49_;
					GTimeSpan _tmp50_;
					gchar* _tmp51_;
					gchar* _tmp52_;
					gchar* _tmp53_;
					_tmp47_ = diff;
					_tmp48_ = seconds;
					diff = _tmp47_ - (_tmp48_ * G_TIME_SPAN_SECOND);
					_tmp49_ = name;
					_tmp50_ = seconds;
					_tmp51_ = g_strdup_printf ("%02ds", (gint) _tmp50_);
					_tmp52_ = _tmp51_;
					_tmp53_ = g_strconcat (_tmp49_, _tmp52_, NULL);
					_g_free0 (name);
					name = _tmp53_;
					_g_free0 (_tmp52_);
				}
				_tmp54_ = name;
				_tmp55_ = diff;
				_tmp56_ = g_strdup_printf ("%06dus", (gint) _tmp55_);
				_tmp57_ = _tmp56_;
				_tmp58_ = g_strconcat (_tmp54_, _tmp57_, NULL);
				_g_free0 (name);
				name = _tmp58_;
				_g_free0 (_tmp57_);
				_g_date_time_unref0 (now);
			}
			_tmp60_ = drt_logger_colorful;
			if (_tmp60_) {
				gint _tmp61_;
				_tmp61_ = color;
				_tmp59_ = _tmp61_ >= 0;
			} else {
				_tmp59_ = FALSE;
			}
			if (_tmp59_) {
				FILE* _tmp62_;
				const gchar* _tmp63_;
				gint _tmp64_;
				const gchar* _tmp65_;
				const gchar* _tmp66_;
				const gchar* _tmp67_;
				_tmp62_ = drt_logger_output;
				_tmp63_ = hint;
				_tmp64_ = color;
				_tmp65_ = name;
				_tmp66_ = domain;
				_tmp67_ = message;
				fprintf (_tmp62_, "%s\x1b[%dm[%-8s %5s]\x1b[0m %s\n", _tmp63_, DRT_LOGGER_COLOR_FOREGROUND + _tmp64_, _tmp65_, _tmp66_, _tmp67_);
			} else {
				FILE* _tmp68_;
				const gchar* _tmp69_;
				const gchar* _tmp70_;
				const gchar* _tmp71_;
				const gchar* _tmp72_;
				_tmp68_ = drt_logger_output;
				_tmp69_ = hint;
				_tmp70_ = name;
				_tmp71_ = domain;
				_tmp72_ = message;
				fprintf (_tmp68_, "%s[%-8s %5s] %s\n", _tmp69_, _tmp70_, _tmp71_, _tmp72_);
			}
			_tmp73_ = drt_logger_output;
			fflush (_tmp73_);
		}
		__finally46:
		{
			FILE* _tmp74_;
			_tmp74_ = drt_logger_output;
			g_rec_mutex_unlock (&__lock_drt_logger_drt_logger_output);
		}
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			_g_free0 (hint);
			_g_free0 (name);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	_g_free0 (hint);
	_g_free0 (name);
}


DrtLogger* drt_logger_construct (GType object_type) {
	DrtLogger* self = NULL;
	self = (DrtLogger*) g_type_create_instance (object_type);
	return self;
}


DrtLogger* drt_logger_new (void) {
	return drt_logger_construct (DRT_TYPE_LOGGER);
}


static void drt_value_logger_init (GValue* value) {
	value->data[0].v_pointer = NULL;
}


static void drt_value_logger_free_value (GValue* value) {
	if (value->data[0].v_pointer) {
		drt_logger_unref (value->data[0].v_pointer);
	}
}


static void drt_value_logger_copy_value (const GValue* src_value, GValue* dest_value) {
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = drt_logger_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer drt_value_logger_peek_pointer (const GValue* value) {
	return value->data[0].v_pointer;
}


static gchar* drt_value_logger_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	if (collect_values[0].v_pointer) {
		DrtLogger * object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = drt_logger_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar* drt_value_logger_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	DrtLogger ** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = drt_logger_ref (value->data[0].v_pointer);
	}
	return NULL;
}


GParamSpec* drt_param_spec_logger (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	DrtParamSpecLogger* spec;
	g_return_val_if_fail (g_type_is_a (object_type, DRT_TYPE_LOGGER), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


gpointer drt_value_get_logger (const GValue* value) {
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, DRT_TYPE_LOGGER), NULL);
	return value->data[0].v_pointer;
}


void drt_value_set_logger (GValue* value, gpointer v_object) {
	DrtLogger * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, DRT_TYPE_LOGGER));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, DRT_TYPE_LOGGER));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		drt_logger_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		drt_logger_unref (old);
	}
}


void drt_value_take_logger (GValue* value, gpointer v_object) {
	DrtLogger * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, DRT_TYPE_LOGGER));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, DRT_TYPE_LOGGER));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		drt_logger_unref (old);
	}
}


static void drt_logger_class_init (DrtLoggerClass * klass) {
	drt_logger_parent_class = g_type_class_peek_parent (klass);
	((DrtLoggerClass *) klass)->finalize = drt_logger_finalize;
	g_rec_mutex_init (&__lock_drt_logger_drt_logger_output);
	g_rec_mutex_init (&__lock_drt_logger_drt_logger_time_ref);
}


static void drt_logger_instance_init (DrtLogger * self) {
	self->ref_count = 1;
}


static void drt_logger_finalize (DrtLogger * obj) {
	DrtLogger * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DRT_TYPE_LOGGER, DrtLogger);
	g_signal_handlers_destroy (self);
}


/**
 * Logger for GLib
 */
GType drt_logger_get_type (void) {
	static volatile gsize drt_logger_type_id__volatile = 0;
	if (g_once_init_enter (&drt_logger_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { drt_value_logger_init, drt_value_logger_free_value, drt_value_logger_copy_value, drt_value_logger_peek_pointer, "p", drt_value_logger_collect_value, "p", drt_value_logger_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (DrtLoggerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) drt_logger_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DrtLogger), 0, (GInstanceInitFunc) drt_logger_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType drt_logger_type_id;
		drt_logger_type_id = g_type_register_fundamental (g_type_fundamental_next (), "DrtLogger", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&drt_logger_type_id__volatile, drt_logger_type_id);
	}
	return drt_logger_type_id__volatile;
}


gpointer drt_logger_ref (gpointer instance) {
	DrtLogger * self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


void drt_logger_unref (gpointer instance) {
	DrtLogger * self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		DRT_LOGGER_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}



