/* Rpc.c generated by valac 0.38.10, the Vala compiler
 * generated from Rpc.vala, do not modify */

/*
 * Copyright 2014-2017 Jiří Janoušek <janousek.jiri@gmail.com>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met: 
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>


#define DRT_TYPE_RPC_FLAGS (drt_rpc_flags_get_type ())

#define DRT_TYPE_RPC_REQUEST (drt_rpc_request_get_type ())
#define DRT_RPC_REQUEST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DRT_TYPE_RPC_REQUEST, DrtRpcRequest))
#define DRT_RPC_REQUEST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DRT_TYPE_RPC_REQUEST, DrtRpcRequestClass))
#define DRT_IS_RPC_REQUEST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DRT_TYPE_RPC_REQUEST))
#define DRT_IS_RPC_REQUEST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DRT_TYPE_RPC_REQUEST))
#define DRT_RPC_REQUEST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DRT_TYPE_RPC_REQUEST, DrtRpcRequestClass))

typedef struct _DrtRpcRequest DrtRpcRequest;
typedef struct _DrtRpcRequestClass DrtRpcRequestClass;
#define _g_variant_type_free0(var) ((var == NULL) ? NULL : (var = (g_variant_type_free (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

typedef enum  {
	DRT_RPC_ERROR_UNKNOWN,
	DRT_RPC_ERROR_REMOTE_ERROR,
	DRT_RPC_ERROR_UNSUPPORTED,
	DRT_RPC_ERROR_IOERROR,
	DRT_RPC_ERROR_INVALID_RESPONSE,
	DRT_RPC_ERROR_INVALID_REQUEST,
	DRT_RPC_ERROR_INVALID_ARGUMENTS,
	DRT_RPC_ERROR_NOT_READY
} DrtRpcError;
#define DRT_RPC_ERROR drt_rpc_error_quark ()
typedef enum  {
	DRT_API_ERROR_UNKNOWN,
	DRT_API_ERROR_INVALID_REQUEST,
	DRT_API_ERROR_INVALID_PARAMS,
	DRT_API_ERROR_PRIVATE_FLAG,
	DRT_API_ERROR_READABLE_FLAG,
	DRT_API_ERROR_WRITABLE_FLAG,
	DRT_API_ERROR_SUBSCRIBE_FLAG,
	DRT_API_ERROR_API_TOKEN_REQUIRED
} DrtApiError;
#define DRT_API_ERROR drt_api_error_quark ()
typedef enum  {
	DRT_RPC_FLAGS_PRIVATE = 1 << 0,
	DRT_RPC_FLAGS_READABLE = 1 << 1,
	DRT_RPC_FLAGS_WRITABLE = 1 << 2,
	DRT_RPC_FLAGS_SUBSCRIBE = 1 << 3
} DrtRpcFlags;

typedef void (*DrtRpcHandler) (DrtRpcRequest* request, void* user_data, GError** error);


GQuark drt_rpc_error_quark (void);
GQuark drt_api_error_quark (void);
GType drt_rpc_flags_get_type (void) G_GNUC_CONST;
gpointer drt_rpc_request_ref (gpointer instance);
void drt_rpc_request_unref (gpointer instance);
GParamSpec* drt_param_spec_rpc_request (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void drt_value_set_rpc_request (GValue* value, gpointer v_object);
void drt_value_take_rpc_request (GValue* value, gpointer v_object);
gpointer drt_value_get_rpc_request (const GValue* value);
GType drt_rpc_request_get_type (void) G_GNUC_CONST;
#define DRT_RPC_TYPE_STRING_ANY "#ANY#"
#define DRT_RPC_RESPONSE_OK "OK"
#define DRT_RPC_RESPONSE_ERROR "ERROR"
void drt_rpc_check_type_string (GVariant* data, const gchar* type_string, GError** error);
gchar* drt_rpc_get_params_type (GVariant* params, GError** error);
gchar* drt_rpc_create_path (const gchar* name);


GQuark drt_rpc_error_quark (void) {
	return g_quark_from_static_string ("drt_rpc_error-quark");
}


GQuark drt_api_error_quark (void) {
	return g_quark_from_static_string ("drt_api_error-quark");
}


GType drt_rpc_flags_get_type (void) {
	static volatile gsize drt_rpc_flags_type_id__volatile = 0;
	if (g_once_init_enter (&drt_rpc_flags_type_id__volatile)) {
		static const GFlagsValue values[] = {{DRT_RPC_FLAGS_PRIVATE, "DRT_RPC_FLAGS_PRIVATE", "private"}, {DRT_RPC_FLAGS_READABLE, "DRT_RPC_FLAGS_READABLE", "readable"}, {DRT_RPC_FLAGS_WRITABLE, "DRT_RPC_FLAGS_WRITABLE", "writable"}, {DRT_RPC_FLAGS_SUBSCRIBE, "DRT_RPC_FLAGS_SUBSCRIBE", "subscribe"}, {0, NULL, NULL}};
		GType drt_rpc_flags_type_id;
		drt_rpc_flags_type_id = g_flags_register_static ("DrtRpcFlags", values);
		g_once_init_leave (&drt_rpc_flags_type_id__volatile, drt_rpc_flags_type_id);
	}
	return drt_rpc_flags_type_id__volatile;
}


void drt_rpc_check_type_string (GVariant* data, const gchar* type_string, GError** error) {
	gboolean _tmp0_ = FALSE;
	const gchar* _tmp1_;
	gboolean _tmp3_ = FALSE;
	GVariant* _tmp4_;
	GVariant* _tmp8_;
	GError * _inner_error_ = NULL;
	_tmp1_ = type_string;
	if (_tmp1_ != NULL) {
		const gchar* _tmp2_;
		_tmp2_ = type_string;
		_tmp0_ = g_strcmp0 (_tmp2_, DRT_RPC_TYPE_STRING_ANY) == 0;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		return;
	}
	_tmp4_ = data;
	if (_tmp4_ == NULL) {
		const gchar* _tmp5_;
		_tmp5_ = type_string;
		_tmp3_ = _tmp5_ != NULL;
	} else {
		_tmp3_ = FALSE;
	}
	if (_tmp3_) {
		const gchar* _tmp6_;
		GError* _tmp7_;
		_tmp6_ = type_string;
		_tmp7_ = g_error_new (DRT_RPC_ERROR, DRT_RPC_ERROR_INVALID_ARGUMENTS, "Invalid data type null, expected '%s'.", _tmp6_);
		_inner_error_ = _tmp7_;
		g_propagate_error (error, _inner_error_);
		return;
	}
	_tmp8_ = data;
	if (_tmp8_ != NULL) {
		const gchar* data_type_string = NULL;
		GVariant* _tmp9_;
		const gchar* _tmp10_;
		const gchar* _tmp11_;
		GVariant* _tmp14_;
		const gchar* _tmp15_;
		gboolean _tmp16_;
		_tmp9_ = data;
		_tmp10_ = g_variant_get_type_string (_tmp9_);
		data_type_string = _tmp10_;
		_tmp11_ = type_string;
		if (_tmp11_ == NULL) {
			const gchar* _tmp12_;
			GError* _tmp13_;
			_tmp12_ = data_type_string;
			_tmp13_ = g_error_new (DRT_RPC_ERROR, DRT_RPC_ERROR_INVALID_ARGUMENTS, "Invalid data type '%s', expected null.", _tmp12_);
			_inner_error_ = _tmp13_;
			g_propagate_error (error, _inner_error_);
			return;
		}
		_tmp14_ = data;
		_tmp15_ = type_string;
		_tmp16_ = g_variant_check_format_string (_tmp14_, _tmp15_, FALSE);
		if (!_tmp16_) {
			const gchar* _tmp17_;
			const gchar* _tmp18_;
			GError* _tmp19_;
			_tmp17_ = data_type_string;
			_tmp18_ = type_string;
			_tmp19_ = g_error_new (DRT_RPC_ERROR, DRT_RPC_ERROR_INVALID_ARGUMENTS, "Invalid data type '%s', expected '%s'.", _tmp17_, _tmp18_);
			_inner_error_ = _tmp19_;
			g_propagate_error (error, _inner_error_);
			return;
		}
	}
}


static gpointer _g_variant_type_copy0 (gpointer self) {
	return self ? g_variant_type_copy (self) : NULL;
}


gchar* drt_rpc_get_params_type (GVariant* params, GError** error) {
	gchar* result = NULL;
	GVariant* _tmp0_;
	GVariantType* type = NULL;
	GVariant* _tmp2_;
	const GVariantType* _tmp3_;
	GVariantType* _tmp4_;
	const GVariantType* _tmp5_;
	gboolean _tmp6_;
	const GVariantType* _tmp8_;
	gboolean _tmp9_;
	GVariant* _tmp15_;
	const gchar* _tmp16_;
	GError* _tmp17_;
	GError * _inner_error_ = NULL;
	_tmp0_ = params;
	if (_tmp0_ == NULL) {
		gchar* _tmp1_;
		_tmp1_ = g_strdup ("tuple");
		result = _tmp1_;
		return result;
	}
	_tmp2_ = params;
	_tmp3_ = g_variant_get_type (_tmp2_);
	_tmp4_ = _g_variant_type_copy0 (_tmp3_);
	type = _tmp4_;
	_tmp5_ = type;
	_tmp6_ = g_variant_type_is_tuple (_tmp5_);
	if (_tmp6_) {
		gchar* _tmp7_;
		_tmp7_ = g_strdup ("tuple");
		result = _tmp7_;
		_g_variant_type_free0 (type);
		return result;
	}
	_tmp8_ = type;
	_tmp9_ = g_variant_type_is_array (_tmp8_);
	if (_tmp9_) {
		const gchar* _tmp10_ = NULL;
		const GVariantType* _tmp11_;
		const GVariantType* _tmp12_;
		gboolean _tmp13_;
		gchar* _tmp14_;
		_tmp11_ = type;
		_tmp12_ = G_VARIANT_TYPE_DICTIONARY;
		_tmp13_ = g_variant_type_is_subtype_of (_tmp11_, _tmp12_);
		if (_tmp13_) {
			_tmp10_ = "dict";
		} else {
			_tmp10_ = "tuple";
		}
		_tmp14_ = g_strdup (_tmp10_);
		result = _tmp14_;
		_g_variant_type_free0 (type);
		return result;
	}
	_tmp15_ = params;
	_tmp16_ = g_variant_get_type_string (_tmp15_);
	_tmp17_ = g_error_new (DRT_RPC_ERROR, DRT_RPC_ERROR_UNSUPPORTED, "Param type %s is not supported.", _tmp16_);
	_inner_error_ = _tmp17_;
	if (_inner_error_->domain == DRT_RPC_ERROR) {
		g_propagate_error (error, _inner_error_);
		_g_variant_type_free0 (type);
		return NULL;
	} else {
		_g_variant_type_free0 (type);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	_g_variant_type_free0 (type);
}


gchar* drt_rpc_create_path (const gchar* name) {
	gchar* result = NULL;
	gchar* dir_path = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (name != NULL, NULL);
	_tmp0_ = g_get_user_cache_dir ();
	_tmp1_ = g_build_filename (_tmp0_, "lds", NULL);
	dir_path = _tmp1_;
	{
		GFile* _tmp2_;
		GFile* _tmp3_;
		_tmp2_ = g_file_new_for_path (dir_path);
		_tmp3_ = _tmp2_;
		g_file_make_directory_with_parents (_tmp3_, NULL, &_inner_error_);
		_g_object_unref0 (_tmp3_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch50_g_error;
		}
	}
	goto __finally50;
	__catch50_g_error:
	{
		GError* e = NULL;
		GError* _tmp4_;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp4_ = e;
		if (!g_error_matches (_tmp4_, G_IO_ERROR, G_IO_ERROR_EXISTS)) {
			GError* _tmp5_;
			const gchar* _tmp6_;
			_tmp5_ = e;
			_tmp6_ = _tmp5_->message;
			g_critical ("Rpc.vala:109: Failed to create directory '%s'. %s", dir_path, _tmp6_);
		}
		_g_error_free0 (e);
	}
	__finally50:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		_g_free0 (dir_path);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	_tmp7_ = name;
	_tmp8_ = g_build_filename (dir_path, _tmp7_, NULL);
	result = _tmp8_;
	_g_free0 (dir_path);
	return result;
}



